# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

from driverng.tests import BaseTest


class TestItm(BaseTest):
    MAPPING_CLASS = "itm"

    def test_order(self):
        self.assertOrderMessageEqual(
            self.WORKLIST_NEW_ADD_DEL,
            """H|^~\\&|||SGL^MCA||ORM|||ITM^ITM|||H2.1^L|20130715141912
            P|1|036666666|||NYME^ANO|NJF|20110513|F
            OBR|1|123456^123456||A~B|A||20130513114242||||N|||20130603110342|Serum|^PRS^^^LOC
            L|1||1|4""",
        )

    def test_result(self):
        date = datetime.datetime(2014, 1, 24, 15, 44, 31)
        self.assertResultEqual(
            """
        H|^~\\&|||ITM^ITM||ORU|||Clarisys^Clarisys||P|H2.1^L|20140124154441
        P|1|03010789658|||TEST^PATIENT1^|NJF|19780605000000|F
        OBR|1|520003049358^520003049358|520003049358^520003049358|grsg~rh1~rh2~rh3~rh4~rh5~kell~rai|||20140123150359|||||||||^741043871^^^/^|||||
        OBX|1|CE|grsg||ab||||||F|||20140124154431||bio
        OBX|2|CE|rh1||pos||||||F|||20140124154431||bio
        OBX|3|CE|rh2||pos||||||F|||20140124154431||bio
        OBX|4|CE|rh3||neg||||||F|||20140124154431||bio
        OBX|5|CE|rh4||neg||||||F|||20140124154431||bio
        OBX|6|CE|rh5||pos||||||F|||20140124154431||bio
        OBX|7|CE|kell||neg||||||F|||20140124154431||bio
        OBX|8|CE|rai||neg||||||F|||20140124154431||bio
        P|2|03010789658|||TEST^PATIENT2^|NJF|19780605000000|F|
        OBR|1|520003049458^520003049458|520003049458^520003049458|grsg~rh1~rh2~rh3~rh4~rh5~kell|||20140123150511|||||||||^741043871^^^/^|||||
        OBX|1|CE|grsg||ab||||||F|||20140124154431||bio
        OBX|2|CE|rh1||pos||||||F|||20140124154431||bio
        OBX|3|CE|rh2||pos||||||F|||20140124154431||bio
        OBX|4|CE|rh3||neg||||||F|||20140124154431||bio
        OBX|5|CE|rh4||neg||||||F|||20140124154431||bio
        OBX|6|CE|rh5||pos||||||F|||20140124154431||bio
        OBX|7|CE|kell||neg||||||F|||20140124154431||bio
        L|1""",
            {
                "520003049358": {
                    "resultats": [
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "ab",
                            "test": "grsg",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "pos",
                            "test": "rh1",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "pos",
                            "test": "rh2",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "neg",
                            "test": "rh3",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "neg",
                            "test": "rh4",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "pos",
                            "test": "rh5",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "neg",
                            "test": "kell",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "neg",
                            "test": "rai",
                            "unit": "",
                            "validator": "bio",
                        },
                    ]
                },
                "520003049458": {
                    "resultats": [
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "ab",
                            "test": "grsg",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "pos",
                            "test": "rh1",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "pos",
                            "test": "rh2",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "neg",
                            "test": "rh3",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "neg",
                            "test": "rh4",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "pos",
                            "test": "rh5",
                            "unit": "",
                            "validator": "bio",
                        },
                        {
                            "analyseur": "",
                            "date": date,
                            "resu": "neg",
                            "test": "kell",
                            "unit": "",
                            "validator": "bio",
                        },
                    ]
                },
            },
        )
